import pytz

from core import Utils
from core.domain.map.GpsSession import GpsSession
from core.domain.optimization.TransportMode import TransportMode


class Var:
	localTimezone = pytz.timezone("Europe/Ljubljana")

	@staticmethod
	def vrpOptimizationFileName() -> str:
		return f"vrpOptimization_{Utils.current_datetime_str()}.bin"

	@staticmethod
	def optimizationFilesZipName(posta: int) -> str:
		return f"{posta}_optimizationFiles.zip"

	@staticmethod
	def download_optimizationFilesZipName(posta: int) -> str:
		timestamp = Utils.current_datetime_str()
		return f"{timestamp}/download_{posta}_optimizationFiles_{timestamp}.zip"

	@staticmethod
	def upload_optimizationFilesZipName(posta: int) -> str:
		return f"upload_{posta}_optimizationFiles_{Utils.current_datetime_str()}.zip"

	@staticmethod
	def optimizationPointsFileName(posta: int) -> str:
		return f"{posta}_optimizationPoints.json"

	@staticmethod
	def gpsFileName(posta: int) -> str:
		return f"{posta}_gps.csv"

	@staticmethod
	def gpsSessionFileName(gpsSession: GpsSession) -> str:
		return f"{gpsSession.id.value}_gpsSession_gps.csv"

	@staticmethod
	def distanceRouteMatrixFileName(posta: int, transportMode: TransportMode) -> str:
		return f"{posta}_{transportMode.value}_distance_matrix.npy"

	@staticmethod
	def durationRouteMatrixFileName(posta: int, transportMode: TransportMode) -> str:
		return f"{posta}_{transportMode.value}_duration_matrix.npy"
