from dataclasses import dataclass

from typing_extensions import Self

from core.domain.optimization.Optimization import Optimization
from core.domain.optimization.TransportMode import TransportMode
from core.types.Id import Id


@dataclass
class OptimizationVehicle:
	optimizationId: Id[Optimization]
	name: str
	type: TransportMode
	capacity: int
	range: float  # Kilometers
	minQuantity: int
	maxQuantity: int
	deliveryTime: float  # Hours
	averageSpeed: float
	maxSpeed: float
	districts: str
	id: Id[Self] = Id.field()
