from abc import ABC, abstractmethod
from typing import Optional

from core.domain.worker.WorkerJob import WorkerJob
from core.domain.worker.WorkerLog import WorkerLog
from core.domain.worker.WorkerLogLevel import WorkerLogLevel
from core.types.Id import Id


class WorkerJobLogRepo(ABC):
	@abstractmethod
	def getAll(self) -> list[WorkerLog]:
		pass

	@abstractmethod
	def get(self, id: Id[WorkerLog]) -> Optional[WorkerLog]:
		pass

	@abstractmethod
	def post(self, context: str, workerJobId: Id[WorkerJob], data: str, level: WorkerLogLevel) -> WorkerLog:
		pass
