from abc import ABC, abstractmethod
from typing import Optional

from core.domain.worker.WorkerJob import WorkerJob
from core.types.Id import Id


class WorkerJobRepo(ABC):
	@abstractmethod
	def getAll(self) -> list[WorkerJob]:
		pass

	@abstractmethod
	def get(self, id: Id[WorkerJob]) -> Optional[WorkerJob]:
		pass

	@abstractmethod
	def post(self, obj: WorkerJob) -> WorkerJob:
		pass
