import logging
import time
from dataclasses import dataclass

from core.domain.worker.Worker import Worker
from core.domain.worker.WorkerStatus import WorkerStatus
from core.repos.WorkerRepo import WorkerRepo
from core.repos.WorkerStatusRepo import WorkerStatusRepo
from core.services.SystemService import SystemService
from core.types.Id import Id

log = logging.getLogger(__name__)


@dataclass
class Log_worker_status:
	workerRepo: WorkerRepo
	workerStatusRepo: WorkerStatusRepo
	systemService: SystemService

	def now(self, id: Id[Worker]):
		log.debug("Check if worker exists and is registered")

		worker = self.workerRepo.get(id=id)

		while True:
			log.debug("Log worker status")
			self.workerStatusRepo.post(
				workerId=worker.id,
				ramAvailable=self.systemService.getRamMbAvailable(),
				cpuUtilization=self.systemService.getCpuUtilization()
			)
			time.sleep(1)
