import datetime
import unittest

from app.App import App
from core.usecases.logging.Log_worker_status import Log_worker_status


class test_Log_worker_status(unittest.TestCase):

	@classmethod
	def setUpClass(cls):
		App.init()

	def test_now(self):
		now = int(datetime.datetime.now().timestamp()) - 1

		App.usecases.register_worker.now()
		result = App.usecases.log_worker_status.now()
		match type(result):
			case Log_worker_status.Result.WorkerNotFound:
				raise Exception("Should not be already created!")
			case Log_worker_status.Result.Ok:
				pass

		self.assertGreater(result.workerStatus.cpuUtilization, 0)
		self.assertGreater(result.workerStatus.ramAvailable, 0)
		self.assertGreater(result.workerStatus.created_at, now)
